'''
Created on 16.04.2022

@author: YK
'''
import win32com.client as win32

''' give the path to the template'''
Template_path = 'C:\Data\Template.docx'
 
''' set a path where the filled template will be saved'''
path_saved_doc = 'C:\Data\saved_doc.docx' 

''' give the names, with which the template will be filled'''
data = ['Petra','Dollar']

''' give the tags of the objects in the template, which would be filled'''
Tag_list = ['firstname', 'lastname']
try:
    try:
        ''' Establish a connection to the word application'''
        word = win32.gencache.EnsureDispatch('Word.Application')
    except Exception as e3:
        print('Error: execution failed - Connection to word via win32.gencache.EnsureDispatch(Word.Application) cannot be established')
        raise(e3)
    word.Visible = False
    ''' open the document so that the filling can be started'''
    doc = word.Documents.Open(Template_path)
    
    ''' loop over the tags and fill them respectively, with the names given in data'''
    for i in range(0,len(Tag_list)):
        try:
            ''' catch the text plain object Tag_list[i]'''
            rng = doc.SelectContentControlsByTag(Tag_list[i]).Item(1).Range
        except Exception as e:
            #print(e)
            print(Tag_list[i] + " cannot be retrieved from " + Template_path)
            continue
        '''get the names given in data'''
        Tex =  data[i]
        '''write the name given in data in the template'''
        rng.Text = Tex
        '''If bookmarks are used, it is appropriate to think about recovering them. The writting process can unfortunately result in deleting them'''
        if not not rng:
            rng.Text = rng
            exec("doc.Bookmarks.Add(\"Bookmark_name_" + str(i) +"\",rng)")
    ''' This part is useful to update cross references related to used Bookmarks, if they are used in the document'''
    doc.Fields.Update()
    doc.PrintPreview()
    doc.ClosePrintPreview()
    ''' This part will save the filled document'''
    doc.SaveAs(path_saved_doc)
except Exception as e3:
    print('Error: execution failed')
    print(e3)
''' close the document and the word object'''
doc.Close(False)
word.Quit()
print('----------------execution finished------------------')